@echo off
setlocal
set batchpath=%~dp0
cls
color F1
echo.
echo  *** Skript pcwMakePE.CMD vytvori modifikovane CD pro zachranu pocitace. 
echo  *** Zakladem je zachranne CD od Microsoftu, ktere si uzivatel rozsiri o dalsi utility.
echo.
echo.
echo  Testuji existenci potrebnych souboru.
if not exist "%batchpath%bbie.exe" (
	echo  Nebyl nalezen soubor BBIE.EXE.
	goto _abort
)
if not exist "%batchpath%mkisofs.exe" (
	echo Nebyl nalezen soubor MKisofs.EXE.
	goto _abort
)
echo  OK...
echo.
for %%i in (_source _target) do set %%i=
for %%n in (B C D E F G H I J K L M N O P Q R S T U V W X Y Z) do (
	if exist %%n:\i386\SETUPLDR.BIN set source=%%n
rem		if exist %%n:\i386\system32\BG*.EXE set source=%%n
rem	)
)

if %source%.==. (
	echo  Nebylo nalezeno originalni zachranne CD od Microsoftu.
	goto _abort
)

for %%n in (B C D E F G H I J K L M N O P Q R S T U V W X Y Z) do (
	if exist %%n:\ if not %%n:==%source%: echo  %%n
)
echo.
echo  K dispozici je (jsou) jako cil tato diskova jednotka (diskove jednotky).
echo  Zadejte pismeno jednotky.
set /p target= 
echo.
if not exist %target%:\* (
	echo  Neplatna diskova jednotka. KONCIM. 
	goto _Abort
)
echo  Zdroj    = %source%:
echo  Cil      = %target%:
echo  Cesta k davkovemu souboru = %batchpath%

:_main
echo.
echo  1) Zkopirovani souboru a vytvoreni souboru ISO
echo  2) Kopirovani souboru
echo  3) Vytvorit pouze soubor ISO
echo.
echo  Q) Konec
echo.

:_mainch
set _ok=
set /p _ok= Vyberte prosim jednu z moznosti: 
if "%_ok%" == "1" goto _CopyFiles
if "%_ok%" == "2" goto _CopyFiles_2
if "%_ok%" == "3" goto _makeiso
if /I "%_ok%" == "q" goto _end
goto :_mainch

:_CopyFiles_2
set CopyOnly=yes

:_CopyFiles
echo  Kopiruji soubory ze zachranneho CD Microsoftu z disku %source%: na disk %target%:
echo.

xcopy /h "%source%:\*.*" "%target%:\minint_custom\disk1\"
call :_copy i386 minint_custom\disk1\
if errorlevel 1 goto _abort
call :_copy programme minint_custom\disk1\
if errorlevel 1 goto _abort

echo.
echo  Extrahuji bootovaci sektor ze zdrojoveho disku %source%: do %target%:\minint_custom
echo.
"%batchpath%bbie.exe" %source%:
if errorlevel 1 goto _abort

copy "%batchpath%image1.bin" "%target%:\minint_custom\disk1\image1.bin"
copy "%batchpath%mkisofs.exe" "%target%:\minint_custom\mkisofs.exe"
copy "%batchpath%cygwin1.dll" %target%:\minint_custom\cygwin1.dll"
if "%CopyOnly%" == "" goto _askUser
goto _end

:_askUser
echo.
echo  Nyni muzete nakopirovat do slozky Programy, kterou vytvorite ve slozce
echo  %target%:\minint_custom\disk1\ dalsi soubory a slozky.
echo  Nechte davkovy soubor prislusnou dobu pozastaveny.
echo.
echo  Pote stisknete klavesu 'P' , ktera spusti vytvoreni obrazu ISO.
echo  V opacnem pripade stisknete klavesu 'Q', kterou cinnost skriptu ukoncite.
echo.

:_wait2
set _ok=
set /p _ok= Vyberte prosim jednu z moznosti [p/q]: 
if /I "%_ok%" == "p" goto _makeiso
if /I "%_ok%" == "q" goto _end
goto :_wait2

:_makeiso
attrib -r -s -h "%target%:\MiniNT_Custom\Disk1\i386\System32\startnet.cmd"
echo  Kontrola zabezpeceni na zachrannem disku od Microsoftu standardne spousti
echo  nastroj pro odstraneni kodliveho softwaru. Potom musite potvrdit dve prohlaseni EULA.
echo  Tuto operaci muzete preskocit a rovnou spustit prikazovy radek.
echo.
set /p pcw= Chcete tuto operaci preskocit? [y-n] ?: 
if /i not %pcw%.==y. goto Original

echo  Zapisuji zjednoduseny skript Startnet.CMD...
ren "%target%:\MiniNT_Custom\Disk1\i386\System32\startnet.cmd" startnet.cm_
echo @echo off > "%target%:\MiniNT_Custom\Disk1\i386\System32\startnet.cmd"
type "%target%:\MiniNT_Custom\Disk1\i386\System32\startnet.cm_" | findstr /i "regsvr32" >>"%target%:\MiniNT_Custom\Disk1\i386\System32\startnet.cmd"
type "%target%:\MiniNT_Custom\Disk1\i386\System32\startnet.cm_" | findstr /i "regedit"  >>"%target%:\MiniNT_Custom\Disk1\i386\System32\startnet.cmd" 
echo color F1 >>"%target%:\MiniNT_Custom\Disk1\i386\System32\startnet.cmd"
echo echo %%path%%  >>"%target%:\MiniNT_Custom\Disk1\i386\System32\startnet.cmd"
echo fsutil fsinfo drives >>"%target%:\MiniNT_Custom\Disk1\i386\System32\startnet.cmd"
:Original

pushd "%batchpath%"
ToUpper.exe /s %target%:\minint_custom\disk1\*
if errorlevel 1 (
	echo  Nepodarilo se najit slozku "%target%:\minint_custom" . KONCIM.
	goto _Abort
)

echo.
echo  Prevod malych pismen na velka
echo.
pushd "%target%:\minint_custom" 
mkisofs.exe -iso-level 4 -r -V "KONTROLA ZABEZPECENI" -no-emul-boot -D -boot-load-seg 0x7C0 -boot-load-size 4 -b IMAGE1.BIN -hide image1-bin -hide boot.catalog  -o pe.iso disk1
echo.
echo.
echo.
echo  Instalace byla dokoncena ...
goto _end

:_copy
echo *********************************************************************
if "%~1" == "" goto :eof
if "%~2" == "" goto :eof
if not exist "%source%:\%~1" goto :eof
echo  Kopiruji soubory z "%source%:\%~1" do "%target%:\%~2"
xcopy /h /e /s "%source%:\%~1\*.*" "%target%:\%~2\%~1\"
goto :eof

:_abort
echo.
echo  Preruseno...
endlocal
pause
goto :eof

:_end

endlocal
echo.
echo  Hotovo
pause